#tag Class
Protected Class App
Inherits ConsoleApplication
	#tag Event
		Function Run(args() as String) As Integer
		  Print "FolderChecker V0.10 by Wolfgang Schwarz" + Chr(13)
		  
		  
		  Dim f As FolderItem 
		  f = New Folderitem("FolderChecker.ini")
		  Dim rowFromFile As String
		  
		  If f <> Nil Then
		    If f.Exists Then
		      
		      Dim t As TextInputStream
		      Try
		        t = TextInputStream.Open(f)
		        t.Encoding = Encodings.UTF8
		        
		        While Not t.EOF
		          rowFromFile = t.ReadLine
		          
		          
		          If NthField(rowFromFile,"=",1) = "reg_from" Then reg_mailfrom = (NthField(rowFromFile,"=",2))
		          If NthField(rowFromFile,"=",1) = "reg_to" Then reg_mailto = (NthField(rowFromFile,"=",2))
		          If NthField(rowFromFile,"=",1) = "reg_subject" Then reg_subject = (NthField(rowFromFile,"=",2))
		          If NthField(rowFromFile,"=",1) = "reg_bodyMsg" Then reg_bodyMsg = (NthField(rowFromFile,"=",2))
		          If NthField(rowFromFile,"=",1) = "reg_smtpServer" Then reg_smtpServer = (NthField(rowFromFile,"=",2))
		          
		          If NthField(rowFromFile,"=",1) = "reg_folderPath" Then 
		            'Print(NthField(rowFromFile,"=",2) + Chr(13))
		            CheckFolder (NthField(rowFromFile,"=",2))
		          End If
		          
		        Wend
		        
		      Catch e As IOException
		        Print("Error accessing file!")
		      End Try
		      t.Close
		    End If
		  End If
		  
		  'If File in Folders then send Mail
		  
		  Print Str(folderCounter) + " Folders checked"
		  Print Str(checkedCounter) + " Folders not empty" 
		  
		  If checkedFolder <> "" Then 
		    SendMail
		    Print checkedFolder
		  End If
		  
		  
		End Function
	#tag EndEvent


	#tag Method, Flags = &h21
		Private Sub CheckFolder(path As String)
		  Dim desktopFolder As FolderItem 
		  Try
		    desktopfolder = New FolderItem (path, FolderItem.PathTypeShell)
		  Catch e As UnsupportedFormatException
		    Print("Folder not found: " + path)
		  End Try
		  
		  If desktopFolder Is Nil Then
		    Return
		  End If
		  
		  Dim count As Integer  = desktopFolder.Count
		  
		  folderCounter = folderCounter + 1
		  
		  If count > 0 Then 
		    checkedCounter = checkedCounter + 1
		    checkedFolder = checkedFolder + path + EndOfLine
		  End If
		  
		  
		  
		End Sub
	#tag EndMethod

	#tag Method, Flags = &h21
		Private Sub SendMail()
		  Dim mail As emailMessage
		  Dim i As Integer
		  Dim s As String
		  Dim MailSocket As New SMTPSocket
		  
		  // set up the socket
		  MailSocket.Address = reg_smtpServer
		  MailSocket.Port = 25
		  
		  // populate the email message
		  mail = New emailMessage
		  mail.FromAddress = reg_mailfrom
		  mail.Subject = reg_subject
		  mail.BodyPlainText = checkedFolder
		  'mail.BodyHTML = htmlFld.Text
		  mail.Headers.AppendHeader("X-Mailer","FolderCkecker SMTP Mailer")
		  
		  // add recipients
		  s = ReplaceAll(reg_mailto, ",", Chr(13))
		  s = ReplaceAll(s, Chr(13) + Chr(10), Chr(13))
		  For i = 1 To CountFields(s, Chr(13))
		    mail.AddRecipient(Trim(NthField(s, Chr(13), i)))
		  Next
		  
		  // send the email
		  MailSocket.Messages.Append(mail)
		  MailSocket.SendMail
		End Sub
	#tag EndMethod


	#tag Note, Name = readme
		
		FolderChecker by Wolfgang Schwarz, www.imcmedia.de
	#tag EndNote


	#tag Property, Flags = &h21
		Private checkedCounter As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private checkedFolder As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private folderCounter As Integer = 0
	#tag EndProperty

	#tag Property, Flags = &h21
		Private reg_bodyMsg As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private reg_mailfrom As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private reg_mailto As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private reg_smtpServer As String
	#tag EndProperty

	#tag Property, Flags = &h21
		Private reg_subject As String
	#tag EndProperty


	#tag ViewBehavior
	#tag EndViewBehavior
End Class
#tag EndClass
